      INTEGER*4 FUNCTION CATFRQ(MOLEC,FREQ,BUFF)
C
C     CATFRQ CALLS
C       CATDIR
C         CALLS  CATRD
C       CATRD
C         CALLS CATFIL
C
C   FUNCTION TO FIND AND RETURN FIRST LINE FOR SPECIES "MOLEC"
C       THAT IS BEYOND FREQ
C
C   CATFRQ <0 IF ERROR FOUND
C   CATFRQ =0 IF FREQ GT FREQUENCY OF LAST LINE
C   CATFRQ >0 POINTS TO LINE 
C
C   BUFF CONTAINS THE LINE INFORMATION
C
C   FREQ IS CHARACTER STRING IN FORMAT (F13.4) OR EQUIVALENT
C
      INTEGER*4 MOLEC,LINE,NLINE,L,R,CATLEN,IERR
      CHARACTER*80  BUFF,BUFFT
      CHARACTER*13  FREQ
  
      NLINE=CATLEN(MOLEC)
      BUFF=' '
C
C     lines  < L have frequency  < FREQ
C     lines >= R have frequency >= FREQ
C
      L=1
      R=NLINE+1
C      DO WHILE (L.LT.R)
 10   IF (L.LT.R) THEN
          LINE=(L+R)/2
          CALL CATRD(MOLEC,LINE,BUFFT,IERR)
          IF(IERR.NE.0) THEN
              CATFRQ=-1
              RETURN
          ENDIF
          IF(LGT(FREQ,BUFFT)) THEN
              L=LINE+1
          ELSE
              R=LINE
              BUFF=BUFFT
          ENDIF
          GO TO 10
C      END DO
      ENDIF
      IF(L.GT.NLINE) THEN
          CATFRQ=0
      ELSE
          CATFRQ=R
      ENDIF
      RETURN
      END
C
      SUBROUTINE CATRD(MOLEC,LINE,BUFF,IERR)
C
C     CATRD CALLS
C       CATFIL
C
C
      INTEGER*4 MOLEC,OMOLEC,LINE,IERR
      CHARACTER*60 FIL
      CHARACTER*80 BUFF
      SAVE OMOLEC
      DATA OMOLEC/-1/
C
C     SUBROUTINE TO READ CATALOGUE FILE FOR MOLECULE "MOLEC",LINE# "LINE"
C
C       80 CHARACTER BUFFER RETURNED IN BUFF
C
C     ERROR CODE RETURNED IN IERR (IOSTAT ERROR #)
C
      IF(MOLEC.NE.OMOLEC) THEN
          OMOLEC=MOLEC
          CALL CATFIL(OMOLEC,FIL)
          OPEN(64,FILE=FIL,IOSTAT=IERR,ACCESS='DIRECT',
     :        FORM='UNFORMATTED',STATUS='OLD',RECL=81,ERR=100)
      ENDIF
C
      READ(64,REC=LINE,IOSTAT=IERR,ERR=100) BUFF
100   RETURN
      END
C
      SUBROUTINE CATFIL(NUM,FIL)
C
C     CATFIL CALLS
C     CALLS  *NONE*
C
      CHARACTER*60 FIL
      INTEGER*4 NUM,II,IQ,IZERO,K,I
C
C     FUNCTION WHICH RETURNS FILE NAME CORRESPONDING TO NUM
C
      CHARACTER*6 CNUM
      IQ=NUM
      IZERO=ICHAR('0')
      IF(NUM.GT.0) THEN
          DO 10 I=6,1,-1
              II=IQ
              IQ=II/10
              K=II-IQ*10
              CNUM(I:I)=CHAR(IZERO+K)
 10           CONTINUE
          FIL='/catalog/c'//CNUM//'.cat'
      ELSE
          FIL='/catalog/catdir.cat'
      ENDIF
      RETURN
      END
C
      INTEGER*4 FUNCTION CATLEN(MOLEC)
C
C
C
C   SUBROUTINE TO RETURN CATALOGUE ENTRY LENGTH
C
C   MOLEC IS SPECIES TAG
C
      INTEGER NSPC,I,K
      PARAMETER (NSPC=512)
      INTEGER*4 MOLEC,NN,MOLST(NSPC),NLEN(NSPC)
      INTEGER*2 VLST(NSPC),LPOSN,NMOL
      CHARACTER*60  FNAME
      CHARACTER*14  CLST(NSPC)
      REAL*4 QLNLST(7,NSPC)
      LOGICAL FIRST
      COMMON /CATCOM/ NMOL,LPOSN,MOLST,NLEN,QLNLST,CLST,VLST
      SAVE /CATCOM/
      DATA FIRST/.TRUE./
C
      IF(FIRST) THEN
          NN=0
          NMOL=0
          FIRST=.FALSE.
          CALL CATFIL(NN,FNAME)
          OPEN (65,FILE=FNAME,STATUS='OLD',ERR=100)
          DO 10 I=1,NSPC
              READ(65,'(I6,A14,I6,7F7.4,I2)',END=20,ERR=20)
     :          MOLST(I),CLST(I),NLEN(I),(QLNLST(K,I),K=1,7),VLST(I)
 10           NMOL=I
 20       LPOSN=NMOL
      ENDIF
      IF(MOLEC.GT.0) THEN
          IF(MOLEC.EQ.MOLST(LPOSN)) THEN
              CATLEN=NLEN(LPOSN)
              RETURN
          ENDIF
          DO 30 I=1,NMOL
              IF(MOLEC.EQ.MOLST(I)) THEN
                  CATLEN=NLEN(I)
                  LPOSN=I
                  RETURN
              ENDIF
 30           CONTINUE
      ENDIF
 100  CATLEN=0
      LPOSN=0
      RETURN
      END
C
      SUBROUTINE CATDIR(MOLEC,MOLNAM,NLINE,QLN,IVER)
C
C
C
C   SUBROUTINE TO RETURN CATALOGUE DIRECTORY INFORMATION
C
C   MOLEC IS SPECIES TAG
C   MOLNAM IS ASCII FIELD SPECIES NAME
C   NLINE IS THE NUMBER OF LINES FOR MOLECULE
C   QLN IS THE LOG10 OF THE PARTITION FUNCTION FOR
C        300,225,150,75,37.5,18.75,9.375 K
C   IVER IS THE VERSION NUMBER
C
C
C
      INTEGER NSPC,NLINE,IVER,I
      PARAMETER (NSPC=512)
      INTEGER*4 MOLEC,MOLST(NSPC),NLEN(NSPC),CATLEN
      CHARACTER*(*)  MOLNAM
      REAL*4 QLN(7)
      INTEGER*2 VLST(NSPC),LPOSN,NMOL
      CHARACTER*14  CLST(NSPC)
      REAL*4 QLNLST(7,NSPC)
      COMMON /CATCOM/ NMOL,LPOSN,MOLST,NLEN,QLNLST,CLST,VLST
      SAVE /CATCOM/
      NLINE=CATLEN(MOLEC)
      IF(NLINE.EQ.0) RETURN
      MOLNAM=CLST(LPOSN)
      DO 10 I=1,7
  10      QLN(I)=QLNLST(I,LPOSN)
      IVER=VLST(LPOSN)
      RETURN
      END
C
      INTEGER*4 FUNCTION NXTDIR(MOLEC)
C
C     FUNCTION NXTDIR RETURNS THE NUMBER OF REMAINING DIRECTORY ENTRIES
C        AFTER INPUT SPECIES MOLEC
C     ON RETURN MOLEC IS CHANGED TO THE NEXT SPECIES TAG
C
C     IF INPUT SPECIES MOLEC = 0 THEN POSITION IS BEFORE FIRST ENTRY
C
C     IF INPUT SPECIES MOLEC = LAST ENTRY THEN MOLEC=0 ON RETURN
C
      INTEGER NSPC
      PARAMETER (NSPC=512)
      INTEGER*4 MOLEC,LN,MOLST(NSPC),NLEN(NSPC),CATLEN
      INTEGER*2 VLST(NSPC),NMOL,LPOSN
      CHARACTER*14  CLST(NSPC)
      REAL*4 QLNLST(7,NSPC)
      COMMON /CATCOM/ NMOL,LPOSN,MOLST,NLEN,QLNLST,CLST,VLST
      SAVE /CATCOM/
      LN=CATLEN(MOLEC)
      NXTDIR=NMOL-LPOSN
      IF(NXTDIR.GT.0) THEN
          LPOSN=LPOSN+1
          MOLEC=MOLST(LPOSN)
      ELSE
          MOLEC=0
      ENDIF
      RETURN
      END
C
      SUBROUTINE LOGFMT(XLOG,XMAN,STR)
C
C     LOGFMT CALLS
C       *NONE*
C
      REAL XLOG,XMAN
      CHARACTER*4 STR
C
C   TAKES XLOG AND RETURNS MANTISSA XMAN AND EXPONENT STRING
C
      INTEGER IE,IA,I,KK,II
      IE=XLOG
      IF(IE.GT.0) THEN
          IE=IE+1
          IA=IE
          STR='E+00'
      ELSE IF(IE.EQ.0) THEN
          STR='    '
          IA=0
      ELSE
          STR='E-00'
          IA=-IE
      ENDIF 
      XMAN=10.**(XLOG-IE) 
      DO 10 I=4,2,-1
      IF(IA.EQ.0) RETURN
      II=IA/10
      KK=IA-II*10 
      IF(I.EQ.2) STR(1:1)=STR(2:2)
      STR(I:I)=CHAR(ICHAR('0')+KK)
  10  IA=II 
      RETURN
      END 

